function score = momcond2(z)
global beta cnt ge emax vvc A B nn gx Me pi fp momcond nn AA BB sv pi gxx T ts nstates emax A B C D v gx cnt beta ge Mx Me fp vvc
a = z(1,1);
sigma = z(2,1);

if min([a; 1/a; sigma; 1/sigma])<.01
    score = Inf;
else
    if (fp == 0)
        tempve = Me*(pi + beta*(AA + (BB+gxx)/sigma));
        rr = max(0,beta(:)*tempve-1/a);
        score = sum( ((nn.*exp( min(0, - sigma*A(:) - B(:)) ) - gx(:)).^2) .* (cnt(:)) ) + sum( ((emax*(1 - exp(-a*rr).*(1 + a*rr)) - ge(:)).^2 ).* (cnt(:)) );
    end    
    if (fp == 1)
        vvc = AA + BB/sigma;
        v2=vvc;
        v1=vvc-0.01;
        while max(abs(v1-v2))>.0001
            v1 = v2;
            v2 = Mx*(pi+beta*(v1+exp(min(0, -sigma*v1))/sigma));
        end
        vvc=v2;
        tempve = Me*(pi+beta*(vvc+exp(min(0, -sigma*vvc))/sigma));
        rr = max(0,beta(:)*tempve-1/a);
        score = sum( ((nn.*exp((min(0, -sigma*vvc(1:sv,:)))) - gx(:)).^2) .* (cnt(:)) ) + sum( ((emax*(1 - exp(-a*rr).*(1 + a*rr)) - ge(:)).^2 ).* (cnt(:)) );
    end
end
